   --  , "" 
   -------------------------------------------------------
   -- (1)    (  ):
   -------------------------------------------------------
   reverse':: [Int] -> [Int]
   reverse' lst | null lst = lst
                | True     = reverse' (tail lst) ++ [head lst]
   -----------------------------------------------------------
   -- (2)    (  ):
   -----------------------------------------------------
   reverse'':: [Int] -> [Int] -> [Int]
   reverse'' lst lst1 | null lst = lst1
                      | True     = reverse'' (tail lst)
                                             (head lst : lst1)
   -----------------------------------------------------------
   -- (3)     :
   -------------------------------------------------
   lstR:: [Int] -> [Int]
   lstR []     = []
   lstR (x:xs) = lstR xs ++ [x]
   ---------------------------------------------
   -- (4)    :
   ---------------------------------------------
   lstR1:: [Int] -> [Int]
   lstR1 []           = []
   lstR1 l@(m@x:f@xs) = lstR1 f ++ [m]
   -- ********************************
   --   :
   -----------------------------------------
   test1 =   reverse' [1,2,3]     == [3,2,1]
          && reverse' []          == [] 
          && reverse' [1..2500]   == reverse [1..2500]
   ---------------------------------------------------
   test2 = reverse'' [1..2500] [] == reverse [1..2500] 
   ---------------------------------------------------
   test3 =   lstR []          == []
          && lstR [1]         == [1]
          && lstR [1,2,3]     == [3,2,1]
          && lstR [1..32767]  == reverse [1..32767]
   ------------------------------------------------
   test4 =   lstR1 []         == []
          && lstR1 [1]        == [1]
          && lstR1 [1,2,3]    == [3,2,1]
          && lstR1 [1..32767] == reverse [1..32767]
